/**
 * Created by zhangjinfei on 2016/9/4.
 */
var EstockProto = function () {
  this.tchart = {};
  this.tdata = {};
  this.vchart = {};
  this.vdata = {};
  this.kchart = {};
  this.kdata = {};
  this.macdChart = {};
  this.macdData = {};
  this._conf = [];
};
EstockProto.prototype = {
  //分时图
  Tchart: function (options) {
    this.tchart[options.TparamsConfig.chartName] = echarts.init($(options.TparamsConfig.chartEl).get(0));
    this.tdata[options.TparamsConfig.chartDateName] = options;
    //this.tchart = echarts.init($("#tchart").get(0));
    //this.tdata = options;
    var config = {
      title: {
        show: false,
      },
      grid: {
        x: options.TparamsConfig.gridX || 15,
        x2: options.TparamsConfig.gridX2 || 15,
        y: options.TparamsConfig.gridY || 25,
        y2: options.TparamsConfig.gridY2 || 25,
        borderWidth: 0
      },
      backgroundColor: options.TparamsConfig.backgroundColor || "",
      animation: false,
      tooltip: {
        show: true,
        showContent: true,
        trigger: 'axis',
        showDelay: 5,
        hideDelay: 5,
        transitionDuration: 0,
        backgroundColor: "#fff",
        borderColor: "#ddd",
        borderRadius: 0,
        borderWidth: 1,
        textStyle: { color: "#666"},
        padding: 10,
        formatter: function (data) {
          var price = data[0].data;
          var dom = "";
          var min = self.minIndex;
          if (price == undefined || Math.abs(price) == min) {
            $("div.echarts-tooltip.zr-element").addClass("hide-important");
          }
          else {
            dom = '<div style="text-align:center;">' + new Date(parseInt(data[0].name)).format("yyyy-MM-dd") + '</div>';
            price = parseFloat(price);
            var p = (price - options.y_close).toFixed(2);
            var pr = (p / options.y_close * 100).toFixed(2) + "%";
            var fontColor = (p >= 0 ? "#DD2200" : "#00A800");
            dom += "时间：" + new Date(parseInt(data[0].name)).format("hh:mm:ss");
            dom += "<br/>价格：<span style='color:" + fontColor + ";'>" + price.toFixed(2) + "</span>";
            dom += "<br/>涨跌：<span style='color:" + fontColor + ";'>" + p + "</span>";
            dom += "<br/>涨跌幅：<span style='color:" + fontColor + ";'>" + pr + "</span>";
            $("div.echarts-tooltip.zr-element").removeClass("hide-important");
          }
          return dom;
        },
        axisPointer: {
          type: 'line',
          lineStyle: { color: 'rgba(150,150,150,0.8)', width: 1, type: 'solid' }
        }
      },
      legend: {
        show: false,
        data: ['-']
      },
      toolbox: {
        show: false,
        feature: {
          mark: { show: true },
          dataView: { show: true, readOnly: false },
          magicType: { show: true, type: ['line', 'bar'] },
          restore: { show: true },
          saveAsImage: { show: true }
        }
      },
      calculable: false,
      xAxis: [
        {
          type: 'category',
          boundaryGap: false,
          axisLine: { show: false },
          axisTick: { show: false, onGap: false },
          axisLabel: {
            rotate: 0,
            margin:8,
            textStyle: { color: '#c8c8c8', align: "center" },
            interval: function (index, data) {
              //var minutes = new Date(parseInt(data)).getMinutes();
              //return minutes == 0 || minutes == 30;
              var t = new Date(parseInt(data)).format("hh:mm");
              if (t == "09:30" || t == "13:00" || t == "15:00") {
                return true;
              }
            },
            formatter: function (data) {
              return new Date(parseInt(data)).format("hh:mm");
            }
          },
          z:1,
          splitNumber: 3,
          itemStyle: { normal: { color: "#1f4e78", } },
          splitLine: { lineStyle: { color: 'rgba(150,150,150,0.2)', width: 1, type: 'solid' } }
        }
      ],
      yAxis: [
        {
          type: 'value',
          position: 'left',
          splitLine: { lineStyle: { color: 'rgba(150,150,150,0.2)', width: 1, type: 'solid' } },
          axisLine: { lineStyle: { color: 'rgba(150,150,150,0.2)', width: 0, type: 'solid' } },
          splitNumber: 4,
          z:1,
          axisLabel: {
            show: false,
            //margin: -40,
            formatter: function (data) {
              //new Estock()._conf.push(data);
              //if (this.cuF.length == 1) return "";
              return data.toFixed(2);
            },
            textStyle: {
              color: function (data) {
                var d = 1*(+data).toFixed(2);
                if (d > options.y_close) return '#dd2200';
                if (d < options.y_close) return '#33aa60';
                if (options.y_close == "--") return '#c8c8c8';
                return '#c8c8c8';
              }
            }
          }
        },
        {
          type: 'value',
          position: 'right',
          boundaryGap: false,
          splitLine: { lineStyle: { color: '#f1f1f1', width: 1, type: 'solid' } },
          axisLine: { lineStyle: { color: '#f1f1f1', width: 0, type: 'solid' } },
          splitNumber: 4,
          axisLabel: {
            show: false,
            //margin: -40,
            formatter: function (data) { return Math.abs(data).toFixed(2) + "%"; },
            textStyle: {
              color: function (data) {
                if (options.y_close == "--") return '#c8c8c8';
                var d = 1 * parseFloat(data).toFixed(3);
                if (d >= 0.001) return '#dd2200';
                if (d < 0) return '#33aa60';
                return '#c8c8c8';
              }
            }
          }
        }
      ],
      series: [
        {
          name: '-',
          type: 'line',
          data: [],
          smooth: false,
          itemStyle: {
            normal: {
              areaStyle: {
                type: 'default',
                color: "#d5e6f5",
              },
              color: "#3186cd",
              borderWidth: 0,
            },
            emphasis: {
              borderWidth: 5,
            }
          },
          z: 0,
          symbol: "circle",
          symbolSize: 0.1,
          showAllSymbol:false,
          clickable: false,
          markPoint: {
            symbol: "circle", symbolSize: 2,large:false,
            itemStyle: { normal: { color: '#3186cd',label:false } },
            effect: {
              show: true,
              type: 'scale',
              loop: true,
              period: 5,
              scaleSize: 5,
              bounceDistance: 10,
              color: '#3186cd',
              shadowColor: '#3186cd',
              shadowBlur: 0
            },
            data: []
          }
        },
        {
          name: '-',
          type: 'line',
          data: [],
          smooth: false,
          itemStyle: {
            normal: {
              lineStyle: { color: "#f4933d", width: 1 }
            }
          },
          z: 5,
          symbol: "circle",
          symbolSize: 0,
          clickable: false
        },
        {
          type: 'line',
          data: [],
          z: 3,
          smooth: false,
          markLine: {
            symbol: "none", clickable: false,large:false,symbolSize: 0,
            itemStyle: { normal: { lineStyle: { color: "#f4933d", width: 1, type: 'dashed' } }, emphasis: { borderWidth: 0 } },
            data: [[
              { name: '', xAxis: 0, yAxis: options.y_close },
              { name: '', xAxis: 240, yAxis: options.y_close }
            ]]
          },
          clickable: false
        }

      ]
    };
    var $this = this;
    $this.drawTchart(options,true,config);
  },
  pushTchart: function (json) {
    //var data = this.tdata;
    var data = this.tdata[json.TparamsConfig.chartDateName];
    if (!json || !json.records || !data)
      return false;
    else if (data.records.length <= 0 || json.records.length <= 0)
      return false;
    if (json.is_forward) {
      var push = json.records[0];
      if (data.records[data.records.length - 1][0] == push[0]) {
        data.records[data.records.length - 1] = push;
      }
      else {
        data.records.push(json.records[0]);
      }
      data.record_date = json.record_date;
      data.y_close = json.y_close;
      data.is_forward = json.is_forward;
    } else {
      data = json;
      /*
       var newXdata = json.records[0],
       newYdata = json.records[1];
       if (!newXdata || !newYdata) return false;
       if (data.records[data.records.length - 1][0] == newXdata[1]) {
       if (newYdata[1] < 0) {
       data.records[data.records.length - 1][1] = 0;
       } else {
       data.records[data.records.length - 1][1] = newYdata[1];
       }
       if (data.records[data.records.length - 2][0] == newXdata[0]) {
       data.records[data.records.length - 2][1] = newYdata[0];
       }
       } else {
       var addData = [];
       if (newYdata[1] < 0) {
       } else {
       addData.push(newXdata[1]);
       addData.push(newYdata[1]);
       data.records.push(addData);
       if (data.records[data.records.length - 2][0] == newXdata[0]) {
       data.records[data.records.length - 2][1] = newYdata[0];
       }
       }
       }
       data.y_close = json.y_close;*/
    }
    this.tdata[json.TparamsConfig.chartDateName] = data;
    var $this = this;
    $this.drawTchart(data,false);
  },
  drawTchart: function (data, isMakeLine, config) {
    if (!data.records || data.records.length == 0) {
      var config = config || this.tchart[data.TparamsConfig.chartName].getOption();
      var xdata = new Array(), ydata = [];
      var ymin, ymax;
      var cdate = new Date();
      var sdata = new Date(cdate.getFullYear(), cdate.getMonth(), cdate.getDate(), 9, 29, 0, 0);
      var step = 1;
      for (var i = 0; i <= 330; i++) {
        if (i < 120 || i >= 210) {
          xdata.push(sdata.addMinutes(step).getTime());
          ydata.push(0);
          step = 1;
        }
        else {
          step++;
        }
      }
      var yAxisRightConfig = config.yAxis[1];
      yAxisRightConfig.min = (0 - 0.01) / 1 * 100;
      yAxisRightConfig.max = (0.01-0) / 1 * 100;
      config.xAxis[0].data = xdata;
      config.series[0].data = ydata;
      //config.series[1].data = averageData;
    } else {
      if (data.records.length == 242) {
        var lastPointX = "",
          lastPointY = "";
      } else {
        if (data.is_forward) {//临时

        } else {
          var lastPointX = data.records.length - 1,
            lastPointY = data.records[lastPointX][1];
        }
      }
      var config = config || this.tchart[data.TparamsConfig.chartName].getOption();
      var xdata = new Array(), tydata = [],ydata = [];
      var ymin, ymax;
      var cdate = new Date();
      var sdata = new Date(cdate.getFullYear(), cdate.getMonth(), cdate.getDate(), 9, 29, 0, 0);
      var step = 1;
      for (var i = 0; i <= 330; i++) {
        if (i <= 120 || i >= 210) {
          xdata.push(sdata.addMinutes(step).getTime());
          ydata.push(0);
          tydata.push(0);
          step = 1;
        }
        else {
          step++;
        }
      }
      $.each(data.records, function (i, n) {
        if (i == 0) {
          ymin = ymax = n[1];
        }
        (function (key, val, array) {
          var index = -1;
          var left = 0;
          var right = array.length;
          while (left <= right) {
            var center = Math.floor((left + right) / 2);
            if (array[center] == key) index = center;
            if (key < array[center]) {
              right = center - 1;
            } else {
              left = center + 1;
            }
          }
          if (index >= 0) {
            ymin = ymin > val ? val : ymin;
            ymax = ymax < val ? val : ymax;
            ydata[index] = val;
          }

        })(n[0], n[1], xdata);
      });
      ymin = parseFloat(ymin);
      ymax = parseFloat(ymax);
      var a = ymin, b = data.y_close, c = ymax;
      var ab = Math.abs(b - a);
      var cb = Math.abs(c - b);
      var speed = parseFloat(ab > cb ? ab : cb);//中心线
      var min = a > b ? (b > c ? c : b) : a;

      if (a >= b && c >= b) {
        min = min - speed;
      }
      else if (a < b && c < b) {
        min = min;
      }
      else {
        min = ymin - speed + (b - ymin);
      }
      self.minIndex = ymin;
      var averageData = [];
      var sum = 0.0;
      //11:30的值取11:29的
      if (ydata.length > 120) {
        ydata[120] = ydata[119];
      }
      // 临时补熔断，需要服务器时间
      totalDots = cdate.getHours() * 60 + cdate.getMinutes() - /*9:30*/570;
      if (totalDots >= 120 && totalDots < 210) {
        // 中午休盘
        totalDots = 120;
      } else if (totalDots >= 210) {
        // 下午盘中
        totalDots -= 90;
      } else if (totalDots > 330) {
        // 下午收盘
        totalDots = 240;
      }
      for (var i = 0; i < ydata.length; i++) {
        if (ydata[i] == 0) {
          ydata[i] = i > 1 && i <= totalDots && ydata[i - 1] ? ydata[i - 1] : undefined;
        }
        if (ydata[i]) {
          sum += +ydata[i];
          averageData.push(sum / (i + 1));
        }
      }
      var markLineData = [
        [
          { name: '', xAxis: 0, yAxis: data.y_close },
          { name: '', xAxis: xdata.length - 1, yAxis: data.y_close }
        ]
      ];
      var yAxisLeftData = new Array();
      var yAxisRightData = new Array();
      var yAxisLeftConfig = config.yAxis[0];
      var yAxisRightConfig = config.yAxis[1];
      var num = yAxisLeftConfig.splitNumber;
      if (ymax == ymin) {
        if (ymin != data.y_close && data.y_close!="--" && data.y_close) {
          var d = data.y_close;
          yAxisLeftConfig.min = d - d * 0.10;
          yAxisLeftConfig.max = d + d * 0.10;
          yAxisRightConfig.min = (yAxisLeftConfig.min - d) / d * 100;;
          yAxisRightConfig.max = (yAxisLeftConfig.max - d) / d * 100;;
          config.xAxis[0].data = xdata;
          config.series[0].data = ydata;
          config.series[1].data = averageData;
        }
        else {
          var d = ymax;
          yAxisLeftConfig.min = d - d * 0.01;
          yAxisLeftConfig.max = d + d * 0.01;
          yAxisRightConfig.min = -0.01 * 100;
          yAxisRightConfig.max = 0.01 * 100;
          config.xAxis[0].data = xdata;
          config.series[0].data = ydata;
          config.series[1].data = averageData;
        }
      } else {
        var labelStep = (ymax - ymin) / num;
        for (var curY = parseFloat(ymin), i = 0; i < num; curY += labelStep, ++i) {
          //var cY = [i, curY]
          yAxisLeftData.push(curY);
          this._conf.push(curY);
          yAxisRightData.push((curY - data.y_close) / data.y_close * 100);
        }
        var spaceHeight = 5;
        if (data.is_forward) {//临时
          for (var i = 0; i <= ydata.length-1; i++){
            if (ydata[i] == undefined) {
              lastPointX = i - 1;
              lastPointY = ydata[i-1];
              break;
            }
          }
        }
        //var lastPointX = xdata.length - 1,
        //    lastPointY = ydata[lastPointInd];
        yAxisLeftConfig.min = data.y_close - speed * 1.2;
        yAxisLeftConfig.max = (+data.y_close) + speed * 1.2;
        yAxisLeftConfig.data = yAxisLeftData;
        yAxisRightConfig.min = (yAxisLeftConfig.min - data.y_close) / data.y_close * 100;
        yAxisRightConfig.max = (yAxisLeftConfig.max - data.y_close) / data.y_close * 100;
        yAxisRightConfig.data = yAxisRightData;
        config.xAxis[0].data = xdata;
        config.series[0].data = ydata;
        config.series[1].data = averageData;
        config.series[0].markPoint.data = [{ xAxis: lastPointX, yAxis: lastPointY }];
      }

    }

    this.tchart[data.TparamsConfig.chartName].setOption(config);
    //this.tchart.setOption(config);
    //this.conF = config;
    //this.tchart.setSeries({ data: ydata }, { data: averageData });
    return config;
  },
  //量图
  Vchart: function (options) {
    /* var paramsConfigs = {
     chartEl: "#vchart",
     chartName: "MIN_V",
     chartDateName: "MIN_DATA",
     showContent: true,// tooltip区域显示与否
     barWidth: 5,//柱形宽度
     gridX :"",
     gridY:"",
     gridX2:"",
     gridY2:"",
     gridWidth:"",
     gridHeight:"",
     };*/
    this.vchart[options.VparamsConfig.chartName] = echarts.init($(options.VparamsConfig.chartEl).get(0));
    this.vdata[options.VparamsConfig.chartDateName] = options;
    var config = {
      title: { show: false },
      grid: {
        x: options.VparamsConfig.gridX1 || 15,
        x2: options.VparamsConfig.gridX2 || 15,
        y: options.VparamsConfig.gridY1 || 0,
        y2: options.VparamsConfig.gridY2 || 50,
        borderWidth: 1,
        borderColor: "#f1f1f1"
      },//{ x: 80, y: 30, y2: 30 },
      animation: false,
      tooltip: {
        trigger: 'axis',
        showDelay: 5,
        textStyle: { color: "#666" },
        showContent: options.VparamsConfig.showContent,
        axisPointer: {
          type: 'line',
          lineStyle: {
            color: 'rgba(150,150,150,0.8)',
            width: 1,
            type: 'solid'
          }
        },
        formatter: function (data) {
          if (options.VparamsConfig.chartName == "MIN_V") {
            var d = data[0];
            var dom = "时间：" + new Date(parseInt(d[1])).format("hh:mm:ss");
            dom += "<br/>成交量：<span>" + d[2] + "</span>";
            return dom;
          } else if (options.VparamsConfig.chartName == "DAY_V") {
            return "";
          }
        },
      },
      legend: {
        show: false,
        data: ['-']
      },
      toolbox: {
        show: false
      },
      calculable: false,
      dataZoom: {
        show: false,
        realtime: true,
        start: 0,
        end: 100
      },
      xAxis: [
        {
          type: 'category',
          boundaryGap: true,
          axisTick: { show: false, onGap: false },
          axisLine: {
            show: true,
            lineStyle: {
              color: '#ddd',
              width: 1,
              type: 'solid'
            }
          },
          //splitNumber: 3,
          axisLabel: {
            show: false,
            width:2,
            rotate: 0, margin: 0,
            textStyle: { color: '#c8c8c8', align: "left" },
            interval: function (index, data) {
              //var minutes = new Date(parseInt(data)).getMinutes();
              //return minutes == 0 || minutes == 30;
              return false;
            },
            formatter: function (data) { return new Date(parseInt(data)).format("hh:mm"); }
          },
          itemStyle: { normal: { color: "#1f4e78", } },
          splitLine: { lineStyle: { color: 'rgba(150,150,150,0.2)', width: 1, type: 'solid' } }
        }
      ],
      yAxis: [
        {
          type: 'value',
          position: "left",
          splitNumber: 2,
          axisLine: { show: false },
          axisLabel: {
            show:false,
            textStyle: { color: '#fff' }
          },
          splitLine: { lineStyle: { color: 'rgba(150,150,150,0.2)', width: 1, type: 'solid' } },
          axisLine: { lineStyle: { color: 'rgba(150,150,150,0.2)', width: 1, type: 'solid' } },
        },
        {
          type: 'value',
          position:"right",
          splitNumber: 2,
          axisLine: { show: false },
          axisLabel: {
            show: false,
            textStyle: { color: '#fff' }
          },
          splitLine: { lineStyle: { color: '#f1f1f1', width: 1, type: 'solid' } },
          axisLine: { lineStyle: { color: '#f1f1f1', width: 1, type: 'solid' } },
        }
      ],
      series: [
        {
          name: '成交量',
          type: 'bar',
          barWidth: options.VparamsConfig.barWidth,
          barMaxWidth: options.VparamsConfig.barWidth,
          itemStyle: {
            normal: {
              color: function (data) {
                if (options.VparamsConfig.type == "MIN_V") {
                  if (!options.ydata || options.ydata.length == 0) {
                  } else {
                    return '#2f84cc';
                  }
                } else if (options.VparamsConfig.type == "DAY_V") {
                  if (!options.records || options.records.length == 0) {
                    //return '#2f84cc';
                  } else {
                    var len = options.records.length;
                    d = len == options.VparamsConfig.dayNum ? options.records[data.dataIndex] : (len < options.VparamsConfig.dayNum ? options.records[data.dataIndex] : options.records[len - options.VparamsConfig.dayNum + data.dataIndex]);
                    //var d = options.records[len - options.VparamsConfig.dayNum + data.dataIndex];
                    if (d[4] > d[1])//d[4]:当日收盘价，d[1]当日开盘价
                      return '#dd2200';
                    else
                      return '#33aa11';
                  }
                }
              }
            }
          }
        }
      ]
    };
    var $this = this;
    $this.drawVchart(options, config);
  },
  pushVchart: function (json) {
    /*var data = this.vdata[json.VparamsConfig.chartDateName];
     if (json.VparamsConfig.chartName == "MIN_V") {
     if (!data || !data.xdata || !data.ydata)
     return false;
     else if (data.xdata.length <= 0 || json.ydata.length <= 0)
     return false;
     var newXdata = json.xdata;
     var newYdata = json.ydata;
     if (data.xdata[data.xdata.length - 1] == newXdata[1]) {
     if (newYdata[1] < 0) {
     data.ydata[data.ydata.length - 1] = 0;
     } else {
     data.ydata[data.ydata.length - 1] = newYdata[1];
     }
     } else {
     data.xdata.push(newXdata[1]);
     if (newYdata[1] < 0) {
     data.ydata.push(0);
     } else {
     data.ydata.push(newYdata[1]);
     }
     }
     if (data.xdata[data.xdata.length - 2] == newXdata[0]) {
     //if (newYdata[0] < 0) {
     //    data.ydata[data.ydata.length - 2] = 0;
     //} else {
     data.ydata[data.ydata.length - 2] = newYdata[0];
     //}
     }
     this.vdata[json.VparamsConfig.chartDateName] = data;
     this.drawVchart(data);
     }*/
    var $this = this;
    $this.drawVchart(json);
  },
  drawVchart: function (data, config) {
    var config = config || this.vchart[data.VparamsConfig.chartName].getOption();
    if (data.VparamsConfig.type == "MIN_V") {
      if (data.ydata.length == 0) {
        var xdata = new Array(), ydata = [];
        var cdate = new Date();
        var sdata = new Date(cdate.getFullYear(), cdate.getMonth(), cdate.getDate(), 9, 29, 0, 0);
        var step = 1;
        for (var i = 0; i <= 330; i++) {
          if (i <= 119 || i > 210) {
            xdata.push(sdata.addMinutes(step).getTime());
            ydata.push(0);
            step = 1;
          }
          else {
            step++;
          }
        }
        config.xAxis[0].data = xdata;
        config.series[0].data = ydata;
        //this.vchart[data.VparamsConfig.chartName].setOption(config);
      } else {
        var xdata = new Array(), ydata = [];
        var cdate = new Date();
        var sdata = new Date(cdate.getFullYear(), cdate.getMonth(), cdate.getDate(), 9, 29, 0, 0);
        var step = 1;
        for (var i = 0; i <= 330; i++) {
          if (i <= 119 || i > 210) {
            xdata.push(sdata.addMinutes(step).getTime());
            ydata.push(0);
            step = 1;
          }
          else {
            step++;
          }
        }
        config.xAxis[0].data = xdata;
        config.series[0].data = data.ydata;
      }
    } else if (data.VparamsConfig.type == "DAY_V") {
      if (data.records.length == 0) {
        var xdata = [], ydata = [], vxdata = [], vydata = [];
        for (var i = 0; i < data.VparamsConfig.dayNum; i++) {
          vxdata.push(i);
          vydata.push(0);
        }
        config.xAxis[0].data = vxdata;
        config.series[0].data = vydata;
      } else {
        var xdata = [], ydata = [], vxdata = [], vydata = [];
        var kmin = data.records[0][3], kmax = data.records[0][2];
        var record = data.records;
        var len = record.length, item,
          isAllLength = len == data.VparamsConfig.dayNum ? false : true;
        var rDl = len < data.VparamsConfig.dayNum ? len : data.VparamsConfig.dayNum,
          dL = data.nowDateNum != undefined ? data.nowDateNum : rDl;
        for (var i = 0; i < dL; i++) {
          if (isAllLength)
            item = len < data.VparamsConfig.dayNum ? record[i] : record[len - data.VparamsConfig.dayNum + i];
          else
            item = record[i];
          xdata.push(item[0]);
          vxdata.push(item[0]);
          //vydata.push((item[5] / 1000000).toFixed(0));
          vydata.push(Math.round(item[5] * 100) / 100);
          //开盘，收盘，最低，最高
          var yarry = [item[1], item[4], item[3], item[2]];
          ydata.push(yarry);

          kmin = Math.min(kmin, item[3]);
          kmax = Math.max(kmax, item[2]);
        }
        var full = rDl,
          leave_date = data.nowDateNum ? full - data.nowDateNum : full - vxdata.length;
        for (var i = 0; i < leave_date; i++) {
          vxdata.push("-");
          vydata.push(0);
        }
        config.xAxis[0].data = vxdata;
        config.series[0].data = vydata;
      }
    }
    this.vchart[data.VparamsConfig.chartName].setOption(config);
  },
  //K线图
  Kchart: function (options) {
    this.kchart[options.KparamsConfig.chartName] = echarts.init($(options.KparamsConfig.chartEl).get(0));
    this.kdata[options.KparamsConfig.chartDateName] = options;
    var showAxisLabel = options.KparamsConfig.showAxisLabel == "false" ? false : true;
    var _this = this;
    //this.kchart = echarts.init($("#D_kchart").get(0));
    //this.kdata = options;
    var config = {
      title: {
        show: false,
        text: ''
      },
      grid: {
        x: options.KparamsConfig.gridX || 15,
        x2: options.KparamsConfig.gridX2 || 15,
        y: options.KparamsConfig.gridY || 20,
        y2: options.KparamsConfig.gridY2 || 25,
        borderWidth: 1,
        borderColor: "#f1f1f1"
      },//{ x: 80, y: 30, y2: 30 },
      animation: false,
      tooltip: {
        trigger: 'axis',
        backgroundColor: "#fff",
        borderColor: "#ddd",
        borderRadius: 0,
        borderWidth: 1,
        position: //[20,20],//function () {//return [0,0];},
          function (data) {
            //var a = $this.kchart[options.KparamsConfig.chartName].getOption();
            //var w = $(options.KparamsConfig.chartEl).width(),
            //    h = $(options.KparamsConfig.chartEl).height();
            //if (data[0] > w / 2)
            //    return [0, 20]
            //else
            //    return [w-120,20];
            return [data[0],20];
          },
        transitionDuration:0,
        textStyle: { color: "#666" },
        showDelay: 5,
        formatter: function (data) {
          var option = _this.kdata[options.KparamsConfig.chartDateName];
          if (option.nowDateNum && data[0].dataIndex >= option.nowDateNum) {
            return "-";
          }
          var date = pub_method.parseISO8601(data[0].name);
          //var date = new Date(data[0].name);
          var dateTxt = option.nowDateNum ? "第" + (data[4].dataIndex+1) + "天" : date.format("yyyy-MM-dd");
          if (data[0].data[0] == "-")
            date = new Date();
          var dom = '<div style="text-align:center;">' + dateTxt + '</div>',
            len = option.records.length,
            isAllLength = len == option.KparamsConfig.dayNum ? false : true;
          if (isAllLength) {
            if (len < option.KparamsConfig.dayNum) {
              var ind = data[0].dataIndex;
              if (data[0].dataIndex == 0)
                var lastVal = [0, 0, 0, 0, data[0].data[0]];//option.lastClosePri;
              else
                var lastVal = option.records[data[0].dataIndex - 1];
            } else {
              var ind = len - option.KparamsConfig.dayNum + data[0].dataIndex;
              var lastVal = option.records[option.records.length - option.KparamsConfig.dayNum + (data[0].dataIndex - 1)];
            }
          } else {
            var ind = data[0].dataIndex;
            if(data[0].dataIndex == 0)
              var lastVal = option.lastClosePri;
            else
              var lastVal = option.records[data[0].dataIndex - 1];
          }
          var volumeData = (option.records[ind][5] / 1000000).toFixed(2),
            ma5 = option.records[ind][6] ? option.records[ind][6].toFixed(2) : "--",
            ma10 = option.records[ind][7] ? option.records[ind][7].toFixed(2) : "--",
            ma20 = option.records[ind][8] ? option.records[ind][8].toFixed(2) : "--",
            ma30 = option.records[ind][9] ? option.records[ind][9].toFixed(2) : "--",
            macd = option.records[ind][10],
            dea = option.records[ind][11],
            dif = option.records[ind][12];
          var dOpenColor = (data[0].data[0] - lastVal[4]) == 0 ? "#222":((data[0].data[0] - lastVal[4]) > 0 ? "#DD2200" : "#00A800"),
            dCloseColor = (data[0].data[1] - lastVal[4]) == 0 ? "#222":((data[0].data[1] - lastVal[4]) > 0 ? "#DD2200" : "#00A800"),
            dHighColor = (data[0].data[3] - lastVal[4]) == 0 ? "#222":((data[0].data[3] - lastVal[4]) > 0 ? "#DD2200" : "#00A800"),
            dLowColor = (data[0].data[2] - lastVal[4]) == 0 ? "#222":((data[0].data[2] - lastVal[4]) > 0 ? "#DD2200" : "#00A800");
          var halVal = (data[0].data[1] - lastVal[4]).toFixed(2),
            halRateVal = ((data[0].data[1] - lastVal[4]) / lastVal[4] * 100).toFixed(2),
            halColor = (data[0].data[1] - lastVal[4]) == 0 ? "#222" : ((data[0].data[1] - lastVal[4]) > 0 ? "#DD2200" : "#00A800");
          if (data[0].data[0] == 0) { }
          $("#ma5").html(ma5);
          $("#ma10").html(ma10);
          $("#ma20").html(ma20);
          $("#ma30").html(ma30);
          $("#dif").html(dif);
          $("#dea").html(dea);
          $("#macd").html(macd);
          if (macd < 0)
            $(".macd").css("color", "#5aaa41");
          else
            $(".macd").css("color", "#d75e5e");
          dom += '开盘价：<span style="color:' + dOpenColor + '">' + data[0].data[0].toFixed(2) + "</span>";
          dom += '<br/>最高价：<span style="color:' + dHighColor + '">' + data[0].data[3].toFixed(2) + "</span>";
          dom += '<br/>最低价：<span style="color:' + dLowColor + '">' + data[0].data[2].toFixed(2) + "</span>";
          dom += '<br/>收盘价：<span style="color:' + dCloseColor + '">' + data[0].data[1].toFixed(2) + "</span>";
          dom += '<br/>涨跌额：<span style="color:' + halColor + '">' + halVal + "</span>";
          dom += '<br/>涨跌幅：<span style="color:' + halColor + '">' + halRateVal + "%</span>";
          dom += "<br/>成交量：<span style='color:#222;'>" + volumeData + "万</span>";
          return dom;
        },
        axisPointer: {
          type: 'cross',
          crossStyle: {
            color: 'rgba(150,150,150,0.8)',
            width: 1,
            type: 'solid'
          }
        }
      },
      legend: {
        data: [{ name: 'MA5', textStyle: { color: "#333" } },//ff7f50
          { name: 'MA10', textStyle: { color: "#333" } },//87cefa
          { name: 'MA20', textStyle: { color: "#333" } },//da70d6
          { name: 'MA30', textStyle: { color: "#333" } }],//32cd32
        show: false,
        x: "left",
        y: "top",
        //backgroundColor: "#fff",
        //borderColor: "#fff",
        //borderWidth: 0,
        itemGap:20,
        padding: [10, 5, 5, 50],
        textStyle: { color: 'auto' },
        selectedMode: false

      },
      calculable: false,
      toolbox: {
        show: false,
        feature: {
          mark: { show: true },
          dataZoom: { show: true },
          dataView: { show: true, readOnly: false },
          magicType: { show: true, type: ['line', 'bar'] },
          restore: { show: true },
          saveAsImage: { show: true }
        }
      },
      dataZoom: {
        show: false,
        realtime: true,
        start: 0,
        end: 100
      },
      xAxis: [
        {
          show: true,
          type: 'category',
          boundaryGap: true,
          axisTick: { show: false, onGap: false },
          axisLabel: {
            show: showAxisLabel,
            margin: 8,
            textStyle: { color: '#c8c8c8', align:"center" }//a0a0a0
          },
          axisLine: { show: false },
          splitNumber: 2,
          itemStyle: { normal: { color: "#1f4e78", } },
          splitLine: { lineStyle: { color: 'rgba(150,150,150,0.1)', width: 1, type: 'solid' } }
        }
      ],
      yAxis: [
        {
          position:"left",
          scale: true,
          boundaryGap: [0.01, 0.01],
          show: true,
          type: 'value',
          axisLabel: {
            show: false,
            formatter: function (data) {
              return data.toFixed(2);
            },
            textStyle: { color: '#c8c8c8' }
          },
          splitNumber: 4,
          axisLine: { show: false },
          splitLine: { lineStyle: { color: 'rgba(150,150,150,0.05)', width: 1, type: 'solid' } },
          axisLine: { lineStyle: { color: 'rgba(150,150,150,0.05)', width: 1, type: 'solid' } },
        },
        {
          type: 'value',
          position:"right",
          scale: true,
          boundaryGap: [0.01, 0.01],
          show: true,
          axisLabel: {
            show: false,
            formatter: function (data) {
              return data.toFixed(2);
            },
            textStyle: { color: '#c8c8c8' }
          },
          splitNumber: 4,
          axisLine: { show: false },
          splitLine: { lineStyle: { color: 'rgba(150,150,150,0.1)', width: 1, type: 'solid' } },
          axisLine: { lineStyle: { color: 'rgba(150,150,150,0.1)', width: 1, type: 'solid' } }
        }
      ],
      series: [
        {
          name: '',
          type: 'k',
          smooth: false,
          itemStyle: {
            normal: {
              areaStyle: { type: 'default', color: "#C4E1FF" },
              color: "#DD2200",
              colorO: "#00A800",
              lineStyle: {
                width: 2,
                color: '#DD2200',
                color0: '#00A800'
              }
            },
            emphasis: {
              color: 'black',
              color0: 'white'
            }
          },
          symbol: "none"
        },
        {
          name: 'MA5',
          type: 'line',
          data: [],
          smooth: false,
          itemStyle: {
            normal: {
              lineStyle: { color: "#cd4343", width: 1 }//3b719b  ff7f50
            }
          },
          z: 5,
          symbol: "none",
          symbolSize: 0,
          clickable: false
        },
        {
          name: 'MA10',
          type: 'line',
          data: [],
          smooth: false,
          itemStyle: {
            normal: {
              lineStyle: { color: "#8c3037", width: 1 }//4dcde2 87cefa
            }
          },
          z: 5,
          symbol: "none",
          symbolSize: 0,
          clickable: false
        },
        {
          name: 'MA20',
          type: 'line',
          data: [],
          smooth: false,
          itemStyle: {
            normal: {
              lineStyle: { color: "#ffb978", width: 1 }//f1588d da70d6
            }
          },
          z: 5,
          symbol: "none",
          symbolSize: 0,
          clickable: false
        },
        {
          name: 'MA30',
          type: 'line',
          data: [],
          smooth: false,
          itemStyle: {
            normal: {
              lineStyle: { color: "#2f55aa", width: 1 }//a7cb46 32cd32
            }
          },
          z: 5,
          symbol: "none",
          symbolSize: 0,
          clickable: false
        }
      ]
    };
    var $this = this;
    $this.drawKchart(options, config);
  },
  pushKchart: function (json) {
    this.kdata[json.KparamsConfig.chartDateName] = json;
    var $this = this;
    $this.drawKchart(json);
  },
  drawKchart: function (data, config) {
    var config = config || this.kchart[data.KparamsConfig.chartName].getOption();
    var xdata = [], ydata = [], MA5 = [], MA10 = [], MA20 = [], MA30 = [];
    var record = data.records,
      len = record.length, item,
      isAllLength = len == data.KparamsConfig.dayNum ? false : true;
    if (isAllLength) {
      if (len < data.KparamsConfig.dayNum) {
        var kmin = data.records[0][3],
          kmax = data.records[0][2];
      } else {
        var kmin = data.records[len - data.KparamsConfig.dayNum][3],
          kmax = data.records[len - data.KparamsConfig.dayNum][2];
      }
    } else {
      var kmin = data.records[0][3],
        kmax = data.records[0][2];
    }
    var getMA = function (nSign, s) {
      var sumMA = 0;
      for (var j = 0; j < s; j++) {
        sumMA += record[nSign - j][4];
      }
      return sumMA/s;
    };
    var rDl = len < data.KparamsConfig.dayNum ? len : data.KparamsConfig.dayNum;
    var dL = data.nowDateNum != undefined ? data.nowDateNum : rDl;
    for (var i = 0; i < dL; i++) {
      if (isAllLength) {
        var nSign = len < data.KparamsConfig.dayNum ? i : len - data.KparamsConfig.dayNum + i;
        /*var a_ma5 = getMA(nSign, 5),
         a_ma10 = getMA(nSign, 10),
         a_ma20 = getMA(nSign, 20),
         a_ma30 = getMA(nSign, 30);*/
        item = record[nSign];
      }
      else {
        item = record[i];
      }
      MA5.push(item[6]);
      MA10.push(item[7]);
      MA20.push(item[8]);
      MA30.push(item[9]);
      xdata.push(item[0]);
      //开盘，收盘，最低，最高
      var yarry = [item[1], item[4], item[3], item[2]];
      ydata.push(yarry);
      kmin = Math.min(kmin, item[3]);
      kmax = Math.max(kmax, item[2]);
    }
    //ma区域
    var maHtml = $('<div class="ma-filed" id="ma-filed" style="position: absolute; top:0;"><span class="ma5" style="margin-left: 15px;">MA5:</span><span class="ma5" id="ma5" style="margin-right:20px;"></span><span class="ma10">MA10:</span><span class="ma10" id="ma10" style="margin-right:20px;"></span><span class="ma20">MA20:</span><span class="ma20" id="ma20" style="margin-right:20px;"></span><span class="ma30 hide">MA30:</span><span class="ma30 hide" id="ma30" style="margin-right:0px;"></span></div>');
    var ls = $("#ma-filed").length;
    if(ls == 0)
      $(data.KparamsConfig.chartEl).append(maHtml);
    $(".ma5").css("color", "#cd4343");
    $(".ma10").css("color", "#8c3037");
    $(".ma20").css("color", "#ffb978");
    $(".ma30").css("color", "#2f55aa");
    var m5 = MA5[dL - 1] ? MA5[dL - 1].toFixed(2) : "--",
      m10 = MA10[dL - 1] ? MA10[dL - 1].toFixed(2) : "--",
      m20 = MA20[dL - 1] ? MA20[dL - 1].toFixed(2) : "--",
      m30 = MA30[dL - 1] ? MA30[dL - 1].toFixed(2) : "--";
    $("#ma5").html(m5);
    $("#ma10").html(m10);
    $("#ma20").html(m20);
    $("#ma30").html(m30);

    var full = rDl,//data.KparamsConfig.dayNum,
      leave_date = data.nowDateNum ? full - data.nowDateNum : full - xdata.length;
    for (var i = 0; i < leave_date; i++) {
      xdata.push("-");
      ydata.push(["-", "-", "-", "-"]);
    }
    config.xAxis[0].data = xdata;
    config.yAxis[0].min = kmin - ((kmax - kmin) / 5);//* 0.93;
    config.yAxis[0].max = kmax + ((kmax - kmin) / 5);//* 1.16;
    config.yAxis[1].min = kmin - ((kmax - kmin) / 5);
    config.yAxis[1].max = kmax + ((kmax - kmin) / 5);
    config.series[0].data = ydata;
    config.series[1].data = MA5;
    config.series[2].data = MA10;
    config.series[3].data = MA20;
    config.series[4].data = MA30;
    this.kchart[data.KparamsConfig.chartName].setOption(config);
  },
  //MACD
  MACDchart: function (options) {
    this.macdChart[options.MACDparamsConfig.chartName] = echarts.init($(options.MACDparamsConfig.chartEl).get(0));
    this.macdData[options.MACDparamsConfig.chartDateName] = options;
    var config = {
      title: { show: false },
      grid: {
        x: options.MACDparamsConfig.gridX1 || 15,
        x2: options.MACDparamsConfig.gridX2 || 15,
        y: options.MACDparamsConfig.gridY1 || 20,
        y2: options.MACDparamsConfig.gridY2 || 50,
        borderWidth: 1,
        borderColor: "#f1f1f1"
      },
      animation: false,
      tooltip: {
        trigger: 'axis',
        showDelay: 5,
        textStyle: { color: "#666" },
        showContent: options.MACDparamsConfig.showContent,
        axisPointer: {
          type: 'line',
          lineStyle: {
            color: 'rgba(150,150,150,0.8)',
            width: 1,
            type: 'solid'
          }
        },
        formatter: function (data) {
          if (options.MACDparamsConfig.chartName == "MIN_V") {
            var d = data[0];
            var dom = "时间：" + new Date(parseInt(d[1])).format("hh:mm:ss");
            dom += "<br/>成交量：<span>" + d[2] + "</span>";
            return dom;
          } else if (options.MACDparamsConfig.chartName == "DAY_V") {
            return "";
          }
        },
      },
      legend: {
        data: [{ name: 'MACD', textStyle: { color: "#333" } },
          { name: 'DIF', textStyle: { color: "#333" } },
          { name: 'DEA', textStyle: { color: "#333" } }],
        show: false,
        x: "left",
        y: "top",
        //backgroundColor: "#fff",
        //borderColor: "#fff",
        //borderWidth: 0,
        itemGap: 20,
        padding: [5, 5, 5, 50],
        textStyle: { color: 'auto' },
        selectedMode: false,
        //formatter: function (data) {
        //var d = data;
        //var a = $this.macdChart[options.MACDparamsConfig.chartName].getOption();
        //var b = 0;
        //}

      },
      toolbox: {
        show: false
      },
      calculable: false,
      dataZoom: {
        show: false,
        realtime: true,
        start: 0,
        end: 100
      },
      xAxis: [
        {
          type: 'category',
          boundaryGap: true,
          axisTick: { show: false, onGap: false },
          axisLine: {
            show: true,
            lineStyle: {
              color: '#ddd',
              width: 1,
              type: 'solid'
            }
          },
          axisLabel: {
            show: false,
            width: 2,
            rotate: 0, margin: 0,
            textStyle: { color: '#c8c8c8', align: "left" },
            interval: function (index, data) {
              return false;
            },
            formatter: function (data) { return new Date(parseInt(data)).format("hh:mm"); }
          },
          itemStyle: { normal: { color: "#1f4e78", } },
          splitLine: { lineStyle: { color: 'rgba(150,150,150,0.2)', width: 1, type: 'solid' } }
        }
      ],
      yAxis: [
        {
          type: 'value',
          position: "left",
          splitNumber: 2,
          axisLine: { show: false },
          axisLabel: {
            show: false,
            textStyle: { color: '#fff' }
          },
          splitLine: { lineStyle: { color: 'rgba(150,150,150,0.2)', width: 1, type: 'solid' } },
          axisLine: { lineStyle: { color: 'rgba(150,150,150,0.2)', width: 1, type: 'solid' } },
        },
        {
          type: 'value',
          position: "right",
          splitNumber: 2,
          axisLine: { show: false },
          axisLabel: {
            show: false,
            textStyle: { color: '#fff' }
          },
          splitLine: { lineStyle: { color: '#f1f1f1', width: 1, type: 'solid' } },
          axisLine: { lineStyle: { color: '#f1f1f1', width: 1, type: 'solid' } },
        }
      ],
      series: [
        {
          name: 'MACD',
          type: 'bar',//e86750   73c55b
          barWidth: options.MACDparamsConfig.barWidth,
          barMaxWidth: options.MACDparamsConfig.barWidth,
          itemStyle: {
            normal: {
              color: function (data) {
                if (!options.records || options.records.length == 0) {
                  //return '#2f84cc';
                } else {
                  //var len = options.records.length;
                  //d = len == options.MACDparamsConfig.dayNum ? options.records[data.dataIndex] : options.records[len - options.VparamsConfig.dayNum + data.dataIndex];
                  //var d = options.records[len - options.VparamsConfig.dayNum + data.dataIndex];
                  if (data.data > 0)
                    return '#e86750';
                  else
                    return '#73c55b';
                }
              }
            }
          }
        },
        {
          name: 'DIF',
          type: 'line',
          data: [],
          smooth: false,
          itemStyle: {
            normal: {
              lineStyle: { color: "#ff7f50", width: 1 }
            }
          },
          z: 5,
          symbol: "none",
          symbolSize: 0,
          clickable: false
        },
        {
          name: 'DEA',
          type: 'line',
          data: [],
          smooth: false,
          itemStyle: {
            normal: {
              lineStyle: { color: "#3b719b", width: 1 }
            }
          },
          z: 5,
          symbol: "none",
          symbolSize: 0,
          clickable: false
        }
      ]
    };
    var $this = this;
    $this.drawMACDchart(options, config);
  },
  pushMACDchart: function (json) {
    var $this = this;
    $this.drawMACDchart(json);
  },
  drawMACDchart: function (data, config) {
    var config = config || this.macdChart[data.MACDparamsConfig.chartName].getOption();
    if (data.records.length == 0) {
      var xdata = [], ydata = [], DIFdata = [], DEAdata = [];
      for (var i = 0; i < data.MACDparamsConfig.dayNum; i++) {
        xdata.push(i);
        ydata.push(0);
      }
      config.xAxis[0].data = xdata;
      config.series[0].data = ydata;
    } else {
      var xdata = [], ydata = [], DIFdata = [], DEAdata = [];
      var kmin = data.records[0][10], kmax = data.records[0][10];
      var record = data.records;
      var len = record.length, item,
        isAllLength = len == data.MACDparamsConfig.dayNum ? false : true;
      var rDl = len < data.MACDparamsConfig.dayNum ? len : data.MACDparamsConfig.dayNum;
      var dL = data.nowDateNum != undefined ? data.nowDateNum : rDl;
      for (var i = 0; i < dL; i++) {
        if (isAllLength)
          item = len < data.MACDparamsConfig.dayNum ? record[i] : record[len - data.MACDparamsConfig.dayNum + i];
        else
          item = record[i];
        xdata.push(item[0]);
        ydata.push(item[10]);
        DEAdata.push(item[11]);
        DIFdata.push(item[12]);
        kmin = Math.min(kmin, item[10], item[11], item[12]);
        kmax = Math.max(kmax, item[10], item[11], item[12]);
      }
      //macd区域
      var macdHtml = $('<div class="ma-filed" id="macd-filed" style="position: absolute;top:0px;"><span class="dif" style="margin-left: 15px;">DIF : </span><span class="dif" id="dif" style="margin-right:15px;"></span><span class="dea">DEA : </span><span class="dea" id="dea" style="margin-right:15px;"></span><span class="macd">MACD : </span><span class="macd" id="macd" style="margin-right:0px;"></span></div>');
      var ls = $("#macd-filed").length;
      if (ls == 0)
        $(data.MACDparamsConfig.chartEl).append(macdHtml);
      $("#dif").html(DIFdata[dL - 1]);
      $("#dea").html(DEAdata[dL - 1]);
      $("#macd").html(ydata[dL - 1]);
      $(".dif").css("color", "#ff7f50");
      $(".dea").css("color", "#3b719b");
      if (ydata[dL - 1] < 0)
        $(".macd").css("color", "#5aaa41")
      else
        $(".macd").css("color", "#d75e5e");//5aaa41
      var full = rDl,
        leave_date = data.nowDateNum ? full - data.nowDateNum : full - xdata.length;
      for (var i = 0; i < leave_date; i++) {
        xdata.push("-");
        ydata.push(0);
      }
      config.yAxis[0].min = kmin - ((kmax - kmin) / 5);
      config.yAxis[0].max = kmax + ((kmax - kmin) / 5);
      config.yAxis[1].min = kmin - ((kmax - kmin) / 5);
      config.yAxis[1].max = kmax + ((kmax - kmin) / 5);
      config.xAxis[0].data = xdata;
      config.series[0].data = ydata;
      config.series[1].data = DIFdata;
      config.series[2].data = DEAdata;

    }
    this.macdChart[data.MACDparamsConfig.chartName].setOption(config);
  },
  //联动
  connectCharts: function (selfChart, otherCharts) {
    var selfChart = eval("(" + selfChart + ")"),
      otherCharts = eval("(" + otherCharts + ")");
    for (var i = 0; i < otherCharts.length; i++) {
      var item = eval("(" + otherCharts[i] + ")")
      selfChart.connect(item);
      item.connect(selfChart);
      if (otherCharts.length > 1) {
        var j = otherCharts.length - 1 - i,
          itemj = eval("(" + otherCharts[j] + ")");
        item.connect(itemj);
        itemj.connect(item);
      }
    }
  },
  //日K 今日数据set
  setTodayDate: function (options) {

  }
};

var Estock = new EstockProto();

//init
// ie9- 兼容trim
String.prototype.trim = function () {
  return this.replace(/(^\s*)|(\s*$)/g, '');
};

Date.prototype.format = function (format) {
  var o = {
    "M+": this.getMonth() + 1, //month
    "d+": this.getDate(), //day
    "h+": this.getHours(), //hour
    "m+": this.getMinutes(), //minute
    "s+": this.getSeconds(), //second
    "q+": Math.floor((this.getMonth() + 3) / 3), //quarter
    "S": this.getMilliseconds() //millisecond
  }

  if (/(y+)/.test(format)) {
    format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
  }

  for (var k in o) {
    if (new RegExp("(" + k + ")").test(format)) {
      format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
    }
  }
  return format;
};
//在当前时间上添加年数
Date.prototype.addYear = function (years) {
  var cyear = this.getFullYear();
  cyear += years;
  this.setYear(cyear);
  return this;
};
//在当前时间上添加天数
Date.prototype.addDay = function (days) {
  var cd = this.getDate();
  cd += days;
  this.setDate(cd);
  return this;
};
//在当前时间上添加月数
Date.prototype.addMonth = function (months) {
  var cm = this.getMonth();
  cm += months;
  this.setMonth(cm);
  return this;
};
//在当前时间上添加分钟
Date.prototype.addMinutes = function (minutes) {
  var cm = this.getMinutes();
  cm += minutes;
  this.setMinutes(cm);
  return this;
};
//在当前时间加上秒数
Date.prototype.addSeconds = function (seconds) {
  var cm = this.getSeconds();
  cm += seconds;
  this.setSeconds(cm);
  return this;
};
//在当前时间上加上小时
Date.prototype.addHours = function (hours) {
  var cm = this.getHours();
  cm += hours;
  this.setHours(cm);
  return this;
}
// 计算当前日期在本月份的周数
Date.prototype.getWeekOfMonth = function (weekStart) {
  weekStart = (weekStart || 0) - 0;
  if (isNaN(weekStart) || weekStart > 6)
    weekStart = 0;

  var dayOfWeek = this.getDay();
  var day = this.getDate();
  return Math.ceil((day - dayOfWeek - 1) / 7) + ((dayOfWeek >= weekStart) ? 1 : 0);
};

var pub_method = {
  //邮箱验证
  isEmail: function (str) {
    var reg = /^([a-zA-Z0-9_-])+@([A-Za-z0-9_-]+[-.])+[A-Za-zd]{2,5}$/;
    return reg.test(str);
  },
  popup: {
    hidePopup: function () {
      // Hide all popups
      $(".mask, .popup, .mask80").removeClass("mask-trans").hide().css({
        "top": 0
      });
    },
    showPopup: function (obj) {
      obj.show();
      $(".mask").show();
      this.positionPopup(obj);
      $(".js-close-popup", obj).click(this.hidePopup);

    },
    positionPopup: function (obj) {
      // Position popup
      obj.css({
        "top": Math.max(0, ($(window).height() - obj.outerHeight()) / 5)
      });
    }
  },
  //popup-error-msg
  popup_err_msg: function (msg) {
    this.popup.hidePopup();
    $("#popup-p-error-msg").html(msg);
    this.popup.showPopup($("#popup-p-error"));
    setTimeout(function () {
      $(".mask, .popup").removeClass("mask-trans").hide().css({
        "top": 0
      });
    }, 2000)
  },
  showError: function (obj) {
    var row = obj.parents(".field-wrapper").eq(0);
    row.addClass("field-error");
    row.before("<div class='error-wrapper'><div><i class='icon icon-x-altx-alt'></i>" + obj.attr("data-error-msg") + "</div></div>")
  },
  //获取网页参数
  get_url_para: function (source, name)//alert(get_url_para(window.location.href,"id"));
  {
    var reg = new RegExp("(^|\\?|&)" + name + "=([^&]*)(\\s|&|$)", "i");
    if (reg.test(source)) return RegExp.$2; return "";
  },
  //日期字符串处理
  get_today_str: function () {
    var today = new Date();
    return today.format("yyyy-MM-dd"); //today.format("yyyy-MM-dd hh:mm:ss");
  },
  get_date_fm: function (str, format) {
    if (str == null || str.length == 0) return "";
    str = str.toString();
    if (navigator.userAgent.indexOf("MSIE 8.0") > 0) {
      str = str.replace(/T/g, " ");;
      if (format == "yyyy-MM-dd") {
        str = str.substr(0, 10);
      }
      return str;
    }

    return new Date(str).format(format);
  },

  //重新格式化日期数据,上面这个日期格式存在时区的问题
  get_date_balance: function (str, format) {
    if (str == null || str.length == 0) return "";
    if (navigator.userAgent.indexOf("MSIE 8.0") > 0) {
      str = str.replace(/T/g, " ");;
      if (format == "yyyy-MM-dd") {
        str = str.substr(0, 10);
      }
      return str;
    }
    var date = str.replace("T", " ");
    return date;
  },
  parseISO8601: function (dateStringInRange) {
    var isoExp = /^\s*(\d{4})-(\d\d)-(\d\d)\s*$/,
      date = new Date(NaN), month,
      parts = isoExp.exec(dateStringInRange);

    if (parts) {
      month = +parts[2];
      date.setFullYear(parts[1], month - 1, parts[3]);
      if (month != date.getMonth() + 1) {
        date.setTime(NaN);
      }
    }
    return date;
  },
  //日期差
  getdiffdays: function (s1, s2) {
    s1 = new Date(s1);
    s2 = new Date(s2);
    var days = s2.getTime() - s1.getTime();
    var time = parseInt(days / (1000 * 60 * 60 * 24));
    return time;
  },
  date_add_days: function (dd, dadd) {
    var a = new Date(dd);
    a = a.valueOf();
    a = a + dadd * 24 * 60 * 60 * 1000;
    a = new Date(a);
    return this.get_date_fm(a, "yyyy-MM-dd");
  },
  getHello: function () {
    var now = new Date();
    var hour = now.getHours();
    if (hour < 6) return "凌晨好";
    else if (hour < 9) return "早上好";
    else if (hour < 12) return "上午好";
    else if (hour < 14) return "中午好";
    else if (hour < 17) return "下午好";
    else if (hour < 19) return "傍晚好";
    else if (hour < 22) return "晚上好";
    else return "夜晚好";
  },
  //小数点后面留2位数字
  pre_format_money: function (nStr) {
    nStr += '';
    var x = nStr.split('.');
    var x1 = x[0];
    var x2 = "";
    if (x.length > 1) {
      x2 = ('.' + x[1].substr(0, 2));
    }

    //如果最后一位数字是零，则舍弃
    if (x2[x2.length - 1] == "0") {
      var len = x2.length;
      x2 = x2.substr(0, len - 1);
    }
    return x1 + x2;
  },
  //账户余额格式化
  format_money_for_zhanghuyue: function (nStr) {
    if (nStr == "0") {
      return "0.00";
    }

    return nStr;
  },
  //金钱格式化
  format_money: function (nStr) {
    nStr += '';
    var x = nStr.split('.');
    var x1 = x[0];
    var x2 = "";
    //&& parseFloat(x[1]) > 0
    if (x.length > 1) {
      x2 = ('.' + x[1]);
    }

    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1)) {
      x1 = x1.replace(rgx, '$1' + ',' + '$2');
    }

    if (x2 == ".0" || x2 == ".") {
      return x1;
    }
    return x1 + x2;
  },

  //判断是否是交易日
  isWorkDateA: function () {
    var date = new Date().getDay();
    var today = new Date().format("yyyy-MM-dd");
    //2016假日列表
    var holidayString = "2016-01-01,2016-02-08, 2016-02-09, 2016-02-10, 2016-02-11, 2016-02-12, 2016-04-04, 2016-05-02, 2016-06-09, 2016-06-10, 2016-09-15, 2016-09-16, 2016-10-03, 2016-10-04, 2016-10-05, 2016-10-06, 2016-10-07";
    if (holidayString.indexOf(today) >= 0) {
      return false;
    }

    if (date == 0 || date == 6) {
      return false;
    }

    return true;
  },
  //判断节假日
  isHoliday: function (date) {
    var holidays = ["1-1", "2-8", "2-9", "2-10", "2-11", "2-12", "4-4", "5-2", "6-9", "6-10", "9-15", "9-16", "10-3", "10-4", "10-5", "10-6", "10-7"];
    var isIn = $.inArray(date, holidays);
    if (isIn >= 0) {
      return false;
    }
  },

  //字符串trim
  trim: function (str) {
    return str.replace(/(^\s*)|(\s*$)/g, "");
  },
  ltrim: function (str) {
    return str.replace(/(^\s*)/g, "");
  },
  rtrim: function (str) {
    return str.replace(/(\s*$)/g, "");
  },

  //得到URL中的参数值
  getUrlVars: function () {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for (var i = 0; i < hashes.length; i++) {
      hash = hashes[i].split('=');
      vars.push(hash[0]);
      vars[hash[0]] = hash[1];
    }
    return vars;
  },
  getParameterByName: function (name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
      results = regex.exec(location.search);
    return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
  },
  //
  IsNullOrEmpty: function (obj) {
    var flag = false;
    if (obj == null || obj == undefined || typeof (obj) == 'undefined' || obj == '') {
      flag = true;
    }
    else if (typeof (obj) == 'string') {
      obj = obj.trim();
      if (obj == '') {//为空
        flag = true;
      } else {//不为空
        obj = obj.toUpperCase();
        if (obj == 'NULL' || obj == 'UNDEFINED' || obj == '{}') {
          flag = true;
        }
      }
    }
    else {
      flag = false;
    }
    return flag;
  },
  isValidTime: function () {
    return true;
    var now = new Date();
    var hour = now.getHours();
    var minute = now.getMinutes();
    var time = hour * 60 + minute;
    if ((555 < time && time < 690) || (780 < time && time < 915)) {
      return true;
    } else {
      return false;
    }
  },
  Dictionary: function () {
    this.data = new Array();

    this.put = function (key, value) {
      this.data[key] = value;
    };

    this.get = function (key) {
      return this.data[key];
    };

    this.remove = function (key) {
      this.data[key] = null;
    };

    this.isEmpty = function () {
      return this.data.length == 0;
    };

    this.size = function () {
      return this.data.length;
    };
  },
  //输入框提示
  inputMsg: function (selector) {
    var base = this;
    /*
     $(selector).on("blur afterpaste change", function () {
     if (base.IsNullOrEmpty($(this).val())) {
     $(this).parent().next().show();
     $(this).on("keyup afterpaste change", function () {
     if (!base.IsNullOrEmpty($(this).val())) {
     $(this).parent().next().hide()
     }
     })
     } else {
     $(this).parent().next().hide()
     }
     })
     */

    $(selector).on("keyup afterpaste change", function () {
      if (!base.IsNullOrEmpty($(this).val())) {
        $(this).parent().next().hide()
      }
    })
  },
  //数字为1位时前面加0
  formatNum: function (m) {
    if (m < 10) {
      m = Math.max(m, 0);
      return ("0" + m);
    } else {
      return m;
    }
  },
  //是否在斗牛场游戏时间
  IfSoloOpen:function(){
    var now = new Date();
    var totalMinutes = now.getHours() * 60 + now.getMinutes();
    // (>= 9:30 && <= 11:20) || (>= 13:00 && <= 14:50)
    return (totalMinutes >= 570 && totalMinutes < 680) || (totalMinutes >= 780 && totalMinutes < 890);
  },
  // A股是否在开盘状态
  isAShareOpen: function () {
    var now = new Date();
    var totalMinutes = now.getHours() * 60 + now.getMinutes();
    // (>= 9:30 && <= 11:30) || (>= 13:00 && <= 15:00)
    return (totalMinutes >= 570 && totalMinutes <= 690) || (totalMinutes >= 780 && totalMinutes <= 900);
  },

  //是否在交易时间(期货)
  isWorkTimeF: function () {
    return this.isAShareOpen();
  },
  //是否在交易时间（股票）
  isWorkTimeA: function () {
    return this.isAShareOpen();
  },
  //是否在9:00~9:30时间段（股票）
  isUnworkTimePart: function () {
    //return true;
    var now = new Date();
    var hour = now.getHours();
    var minute = now.getMinutes();
    var m = hour * 60 + minute;
    if (m > 540 && m < 570) { return true; }//09:00~09:30
    else { return false; }
  },
  // 千位分隔符
  formatNumThousand: function (num) {
    var isNeg = num < 0 ? true : false;
    //var str = String(Math.abs(num));
    //var len = str.length;
    //if (len <= 3) {
    //    return String(num);
    //}
    //var mod = len % 3;
    //var arr = [];
    //for (var i = 0; i < len; i++) {
    //    if (((i - mod) % 3) == 0) {
    //        arr.push(",");
    //    }
    //    arr.push(str[i]);
    //}
    //if (isNeg) {
    //    return "-" + arr.join("");
    //} else {
    //    return arr.join("");
    //}
    var str = String(Math.abs(num));
    var array = str.split('.');
    var integerStr = array[0];
    var subfix = array.length > 1 ? '.' + array[1] : '';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(integerStr)) {
      integerStr = integerStr.replace(rgx, '$1' + ',' + '$2');
    }
    if (isNeg) {
      return "-" + integerStr + subfix;
    } else {
      return integerStr + subfix;
    }
  },

  //期指交易时间倒计时
  openState: function () {
    return this.AshareOpenState();
  },

  //A股交易时间倒计时
  AshareOpenState: function () {
    var circuitBreaker = false;

    var base = this;
    var now = new Date();
    $("#date").html(now.format("yyyy-MM-dd"));
    var hour = now.getHours();
    var minute = now.getMinutes();
    var second = now.getSeconds();
    var dataTxt = $("#dateTxt"),
      time = $("#time"),
      tip = $("#time + em"),
      date = dataTxt.parent(),
      icon = date.parent().find("i");
    var m = hour * 60 + minute;

    var countdown = function (time) {
      if (time == 0) {
        $("#time").html("00:00:00");
        return false;
      }
      var count = time - m;
      var hourStr = base.formatNum(Math.floor(count / 60));
      var minStr = (count % 60) - 1;
      minStr = Math.max(minStr, 0);

      var minuteStr = base.formatNum(minStr);
      var secondStr = base.formatNum(59 - second);
      $("#time").html(hourStr + ":" + minuteStr + ":" + secondStr);
    };

    var stateOn = function () {
      date.removeClass("off");
      icon.removeClass("icon-rest").addClass("icon-clock").removeClass("off");
    };
    var stateOff = function () {
      date.addClass("off");
      icon.removeClass("icon-clock").addClass("off icon-rest");
    };
    if (!base.isWorkDateA()) {
      dataTxt.html("非开盘日");
      tip.html("未开");
      countdown(0);
      return false;
    } else if (circuitBreaker || (m >= 900 && m <= 1440)) {
      dataTxt.html("明日再战");
      $("#time").html("00:00:00");
    } else if (m < 570) {
      dataTxt.html("等待开盘");
      tip.html("开盘");
      countdown(570);
    } else if (m < 690) {
      dataTxt.html("正在进行");
      tip.html("结束");
      countdown(690);
    } else if (m < 780) {
      dataTxt.html("午间休盘");
      tip.html("开盘");
      countdown(780);
    } else if (m < 900) {
      dataTxt.html("正在进行");
      tip.html("结束");
      countdown(900);
    }
  },

  // 获得当前IF主力合约
  getIfContract: function () {
    return 'IF1604';
  },
  //解析访问路径
  parsePath: function (path, token) {
    if (!token) {
      token = "&";
    }
    var result = [];
    var array1 = path.split(token);
    for (var i = 0; i < array1.length; i++) {
      var array2 = array1[i].split("=");
      result[array2[0]] = array2[1];
    }

    return result;
  },
  //中英文字符长度
  strlen: function (str) {
    var len = 0;
    for (var i = 0; i < str.length; i++) {
      var c = str.charCodeAt(i);
      //单字节加1
      if ((c >= 0x0001 && c <= 0x007e) || (0xff60 <= c && c <= 0xff9f)) {
        len++;
      }
      else {
        len += 2;
      }
    }
    return len;
  },
  GetDictList: function (dict, parent) {
    var base = this;
    var arr = [];
    $.each(dict, function (i, n) {
      if (base.IsNullOrEmpty(parent) && base.IsNullOrEmpty(n.parent_id)) {
        arr.push(eval("({id:'" + i + "',name:'" + n + "'})"));
      }
      if (!base.IsNullOrEmpty(parent) && !base.IsNullOrEmpty(n.parent_id)) {
        if (n.parent_id == parent) {
          arr.push(eval("({id:'" + i + "',name:'" + n.name + "',parent_id:'" + n.parent_id + "'})"));
        }
      }
    });
    return arr;
  }

}
